import chalib
from Splitter import Splitter
from ExtensionClass import Base
from string import split, join
import thread
import kconv

jsplitter_lock=thread.allocate_lock()
to_euc=kconv.Kconv(kconv.EUC)

# We get part-of-speech codes back from chalib which we then use to
#  judge which words to index.  Run 'chasen -lp' to get a list of
#  codes.  This list is of the codes for parts-of-speech we want to
#  keep.
keepcodes=range(1,13) + range(16,25) + \
           [36, 37, 38, 44, 45, 48, 49, 52, 53, 54, 55, 72, 78, 82, 84]

class JSplitter(Base, Splitter):
    """ First try at a Japanese-capable Splitter. """

    def __init__(self, doc, synstop={}):
        jsplitter_lock.acquire() # chalib is not thread-safe
        doc=to_euc.convert(doc)
        c=split(chalib.sparse_tostr(doc, "%M\t%h\n"), '\n')
        jsplitter_lock.release()
        
        c=filter(lambda x: x != 'EOS' and x != '', c)
        d=[]
        for i in c:
            word, code=split(i, '\t')
            if int(code) in keepcodes:
                d.append(word)
        text=join(d, ' ')
        Splitter.__init__(self, text, synstop)
